/*
 * AspectFrame.h
 * 
 * Copyright (C) 2008 Matthias Schiffer <matthias@gamezock.de>
 * 
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef ZOOMEDIT_GUI_ASPECTFRAME_H_
#define ZOOMEDIT_GUI_ASPECTFRAME_H_

#include <gtkmm/aspectframe.h>
#include <gtkmm/builder.h>

namespace ZoomEdit {
namespace Gui {

class AspectFrame : public Gtk::AspectFrame {
  private:
    int width;
    
    void onSizeAllocate(Gtk::Allocation &allocation) {
      if(allocation.get_width() == width)
        return;
      
      width = allocation.get_width();
      
      set_size_request(-1, width/property_ratio().get_value());
    }
    
  public:
    AspectFrame(BaseObjectType *cobject, const Glib::RefPtr<Gtk::Builder>&)
    : Gtk::AspectFrame(cobject), width(-1) {
      signal_size_allocate().connect(sigc::mem_fun(this, &AspectFrame::onSizeAllocate));
    }
};

}
}

#endif /*ZOOMEDIT_GUI_ASPECTFRAME_H_*/
